import { PageEvent } from '@angular/material';
import { Subject } from 'rxjs';
import { MatMultiSortTableDataSource } from './mat-multi-sort-data-source';
export declare class TableData<T> {
    private _dataSource;
    private _columns;
    private _displayedColumns;
    pageSize: number;
    pageIndex: number;
    private _pageSizeOptions;
    private _totalElements;
    private _sortParams;
    private _sortDirs;
    private _nextObservable;
    private _previousObservable;
    private _sizeObservable;
    private _sortObservable;
    constructor(columns: {
        id: string;
        name: string;
    }[], options?: {
        defaultSortParams?: string[];
        defaultSortDirs?: string[];
        pageSizeOptions?: number[];
        totalElements?: number;
    });
    onSortEvent(): void;
    onPagnationEvent($event: PageEvent): void;
    totalElements: number;
    displayedColumns: string[];
    dataSource: MatMultiSortTableDataSource<T>;
    updateSortheaders(): void;
    data: T[];
    readonly nextObservable: Subject<any>;
    readonly previousObservable: Subject<any>;
    readonly sizeObservable: Subject<any>;
    readonly sortObservable: Subject<any>;
    sortParams: string[];
    sortDirs: string[];
    readonly columns: {
        id: string;
        name: string;
    }[];
    readonly pageSizeOptions: number[];
}
